/****************************************************************************/
/*                                                                          */
/*                      Chaine de CAO & VLSI   Alliance                     */
/*                                                                          */
/*    Produit : YAGLE  v2.02                                                */
/*    Fichier : yag202.h                                                    */
/*                                                                          */
/*    (c) copyright 1994 Laboratoire MASI equipe CAO & VLSI                 */
/*    Tous droits reserves                                                  */
/*    Support : e-mail alliance-support@asim.lip6.fr                        */
/*                                                                          */
/*                                                                          */
/****************************************************************************/

#ifndef YAG
#define YAG

#include CNS_H

/* signal types */

#define YAG_SIGINT     ((char) 'I' )
#define YAG_SIGEXT     ((char) 'E' )
#define YAG_SIGVDD     ((char) 'D' )
#define YAG_SIGVSS     ((char) 'S' )

/* disassembly mode masks */

#define YAG_GENBEFIG   ((long) 0x00000001 )
#define YAG_GENLOFIG   ((long) 0x00000002 )

/* transistor overtyping */

#define CAPACITE       ((char) 0x10 )
#define BLEEDER        ((char) 0x20 )
#define RESIST         ((char) 0x40 )
#define DIODE          ((char) 0x80 )
#define USED           ((char) 0x01 )
#define ORIENTED       ((char) 0x02 )

/* link overtyping */

#define YAG_TNLINK     ((long) 0x80000000 )
#define YAG_TPLINK     ((long) 0x40000000 )

/* branch overtyping */

#define YAG_RESIST     ((long) 0x80000000 )
#define YAG_PULLUP     ((long) 0x20000000 )
#define YAG_IGNORE     ((long) 0x10000000 )
#define YAG_MARKFALSE  ((long) 0x00200000 )  
#define YAG_TREATED    ((long) 0x00100000 )

#define YAG_MASK_PARA (CNS_PARALLEL_INS & ~CNS_PARALLEL)

/* cone overtyping */

#define YAG_DELETED    ((long) 0x80000000 )
#define YAG_PARTIAL    ((long) 0x40000000 )
#define YAG_FORCED     ((long) 0x20000000 )
#define YAG_GLUECONE   ((long) 0x10000000 )
#define YAG_TEMPCONE   ((long) 0x08000000 )
#define YAG_CELLOUT    ((long) 0x04000000 )
#define YAG_HASDUAL    ((long) 0x02000000 )
#define YAG_CONESEEN   ((long) 0x01000000 )
#define YAG_CONSTRAINT ((long) 0x00800000 )
#define YAG_STOP       ((long) 0x00400000 )
#define YAG_MARK       ((long) 0x00200000 )  
#define YAG_VISITED    ((long) 0x00100000 )  
#define YAG_LOOPCONF   ((long) 0x00080000 )  
#define YAG_FALSECONF  ((long) 0x00040000 )  

/* edge overtyping */

#define YAG_MARK       ((long) 0x00200000 )  
#define YAG_IGNORE     ((long) 0x10000000 )  

/* cell types */

#define YAG_CELL_MS_SC     ((long) 0x00000001 )
#define YAG_CELL_MSS_SC    ((long) 0x00000002 )
#define YAG_CELL_MSR_SC    ((long) 0x00000003 )
#define YAG_CELL_MSDIFF    ((long) 0x00000004 )
#define YAG_CELL_FFT2      ((long) 0x00000005 )
#define YAG_CELL_FD2R      ((long) 0x00000006 )
#define YAG_CELL_FD2S      ((long) 0x00000007 )
#define YAG_CELL_LD1       ((long) 0x00000008 )
#define YAG_CELL_LD1R      ((long) 0x00000009 )
#define YAG_CELL_BINAND    ((long) 0x0000000a )
#define YAG_CELL_BINOR     ((long) 0x0000000b )

/* for the cnsfig USER field */

#define YAG_TEMPCONE_PTYPE     ((long) 0x10000001 )
#define YAG_GLUECONE_PTYPE     ((long) 0x10000002 )

/* for the cone USER field */

#define YAG_MEMORY_PTYPE       ((long) 0x10000002 )
#define YAG_UPEXPR_PTYPE       ((long) 0x10000003 )
#define YAG_DNEXPR_PTYPE       ((long) 0x10000004 )
#define YAG_INPUTS_PTYPE       ((long) 0x10000005 )
#define YAG_WEIGHT_PTYPE       ((long) 0x10000006 )
#define YAG_MODEL_PTYPE        ((long) 0x10000007 )
#define YAG_OLDNAME_PTYPE      ((long) 0x10000008 )
#define YAG_OLDINDEX_PTYPE     ((long) 0x10000009 )
#define YAG_SIGNAL_PTYPE       ((long) 0x1000000a )
#define YAG_LATCHINFO_PTYPE    ((long) 0x1000000b )
#define YAG_BISTABLE_PTYPE     ((long) 0x1000000c )
#define YAG_INCONE_PTYPE       ((long) 0x10000012 )
#define YAG_BACK_PTYPE         ((long) 0x10000013 )
#define YAG_DUALEXPR_PTYPE     ((long) 0x10000014 )
#define YAG_DUALINPUTS_PTYPE   ((long) 0x10000015 )

/* for the edge USER field */

#define YAG_WEIGHT_PTYPE       ((long) 0x10000006 )
#define YAG_MODEL_PTYPE        ((long) 0x10000007 )

/* for the branch USER field */

#define YAG_WEIGHT_PTYPE       ((long) 0x10000006 )
#define YAG_SIGLIST_PTYPE      ((long) 0x1000000d )
#define YAG_LOCONLIST_PTYPE    ((long) 0x1000000e )

/* for the cell USER field */

#define YAG_SIGLIST_PTYPE      ((long) 0x1000000d )

/* for the connector USER field */

#define YAG_CONSTRAINT_PTYPE   ((long) 0x1000000f )
#define YAG_SIGNAL_PTYPE       ((long) 0x1000000a )
#define YAG_OLDNAME_PTYPE      ((long) 0x10000008 )

/* for the signal USER field */

#define YAG_CONE_PTYPE         ((long) 0x10000010 )
#define YAG_VAL_S_PTYPE        ((long) 0x10000011 )

/* for the transistor USER field */

#define YAG_GRIDCON_PTYPE      ((long) 0x10000014 )

/* for bequad USER field */

#define YAG_CONE_PTYPE         ((long) 0x10000010 )

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#define YAG_YES 1
#define YAG_NO 0

#define VDD_BRANCH 0
#define VSS_BRANCH 1
#define EXT_BRANCH 2
#define GND_BRANCH 3

#define A_LOT_OF_BRANCHES 200

/* branch group */

typedef struct {
    branch_list     *BREXT,     /* list of external branches */
                    *BRVDD,     /* list of branches to VDD */
                    *BRVSS,     /* list of branches to VSS */
                    *BRGND;     /* list of branches to GND */
} branch_group;

/* Global variables */

extern short            YAG_DEPTH;          /* functional analysis depth   */
extern short            YAG_MAX_LINKS;      /* max length of one branch    */
extern short            YAG_USE_FCF;        /* !=0 if FCF analysis used    */
extern short            YAG_VECTORISE;      /* !=0 to vectorise figures    */
extern short            YAG_ORIENT;         /* transistor orientation      */
extern short            YAG_PROP_HZ;        /* FCF through HZ nodes        */
extern short            YAG_MAKE_CELLS;     /* cell detection              */
extern short            YAG_CELL_SHARE;     /* cones in multiple cells     */
extern short            YAG_DETECT_LATCHES; /* latch detection             */
extern short            YAG_FCL_DETECT;     /* cell detection using FCL    */
extern short            YAG_ONE_SUPPLY;     /* single vdd and vss in vbe   */
extern short            YAG_FLIP_FLOP_SLAVE;/* slave marked as flip-flop   */

extern long             YAGLE_NB_ERR;
extern chain_list      *YAGLE_RECAP_ERR;

extern int              YAGLE_STAT_MODE;
extern int              YAGLE_TRACE_MODE;
extern int              YAGLE_DEBUG_MODE;
extern int              YAGLE_SILENT_MODE;
extern int              YAGLE_HELP_S;

extern char             YAG_FIGNAME[];      /* cone netlist figure name */
extern char             YAG_VBENAME[];      /* behavioural figure name */

extern char            *YAGLE_VERSION;
extern char            *YAGLE_DATE;
extern char             YAGLE_LANG;

/* Function declarations */

cnsfig_list            *yagDisassemble();
void                    yagenv();

#endif


